unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLCoordinates, GLCrossPlatform, BaseClasses,
  GLWin32Viewer, jpeg, Menus, GLGeomObjects, ComCtrls, ImgList, ToolWin,
  GLSkydome;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    centro: TGLDummyCube;
    raiz: TGLDummyCube;
    GLCube1: TGLCube;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    extura1: TMenuItem;
    Cargar1: TMenuItem;
    Salvar1: TMenuItem;
    Cargar2: TMenuItem;
    Foto1: TMenuItem;
    N1: TMenuItem;
    Slir1: TMenuItem;
    GLSphere1: TGLSphere;
    GLCylinder1: TGLCylinder;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    GLSkyDome1: TGLSkyDome;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Cargar1Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
    ss    : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := 1.0;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.05;
  if ss < 0.2 then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.05;
  if ss > 2.5 then ss := 2.5;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

procedure TForm1.Cargar1Click(Sender: TObject);
var
  nom : string;
begin
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;
    GLCube1.Material.Texture.Image.LoadFromFile(nom);
  end;
end;

end.
